enum TaskState {
  PLANNED = 0;
  RUNNING = 1;
  FINISHED = 2;
  CANCELED = 3;
  ABORTED = 4;
  FAILED = 5;
}

enum ErrorType {
  USER_ERROR = 0;
  INTERNAL_ERROR = 1;
  INSUFFICIENT_RESOURCES = 2;
  EXTERNAL = 3;
}

struct Lifespan {
  1: bool grouped;
  2: i32 groupId;
}

struct ErrorLocation {
  1: i32 lineNumber;
  2: i32 columnNumber;
}

struct HostAddress {
  1: string host;
  2: i32 port;
}

struct TaskStatus {
  1: i64 taskInstanceIdLeastSignificantBits;
  2: i64 taskInstanceIdMostSignificantBits;
  3: i64 version;
  4: TaskState state;
  5: string selfUri;
  6: set<Lifespan> completedDriverGroups;
  7: list<ExecutionFailureInfo> failures;
  8: i32 queuedPartitionedDrivers;
  9: i32 runningPartitionedDrivers;
  10: double outputBufferUtilization;
  11: bool outputBufferOverutilized;
  12: i64 physicalWrittenDataSizeInBytes;
  13: i64 memoryReservationInBytes;
  14: i64 systemMemoryReservationInBytes;
  15: i64 fullGcCount;
  16: i64 fullGcTimeInMillis;
  17: i64 peakNodeTotalMemoryReservationInBytes;
  18: i64 totalCpuTimeInNanos;
  19: i64 taskAgeInMillis;
  20: i64 queuedPartitionedSplitsWeight;
  21: i64 runningPartitionedSplitsWeight;
}

struct ErrorCode {
  1: i32 code;
  2: string name;
  3: ErrorType type;
  4: bool retriable;
}

struct ExecutionFailureInfo {
  1: string type;
  2: string message;
  3: optional ExecutionFailureInfo cause;
  4: list<ExecutionFailureInfo> suppressed;
  5: list<string> stack;
  6: ErrorLocation errorLocation;
  7: ErrorCode errorCode;
  8: HostAddress remoteHost;
}
